Ticket #31413

Excel セル番地の読み上げの変更

Open Date: 2013-05-21 22:06 Last Update: 2013-10-11 20:57

Reporter:
Owner:
(None)
Status:
Open
Component:
(None)
MileStone:
(None)
Priority:
5 - Medium
Severity:
5 - Medium
Resolution:
Accepted
File:
None

Details

Excel のセル番地の読み上げを、内容の前に読むか、内容の後に読むか、選べるようにしてほしいという要望を伺っています。

以下の趣旨のご要望ではないかと思うのですが、解決方法など、もう少し検討します。

  • 現在、セルを移動したときには "太郎 A1" "次郎 A2" "花子 A3" のように読むが、セル範囲の選択を行ったときには "A1 太郎 から A2 次郎 選択" "A1 太郎 から A3 花子 選択" のように読み上げる。
  • このセル範囲の読み上げはセル移動の読み上げと一貫性がなく、しかも非効率的である。
  • セル範囲読み上げの「から」「選択」は不要ではないか?

Ticket History (3/11 Histories)

2013-05-21 22:06 Updated by: nishimoto
  • New Ticket "Excel セル番地の読み上げの改善要望" created
2013-06-03 18:38 Updated by: nishimoto
Comment

NVDA 2013.1jp は Excel 2013 に対応できておらず、セルの範囲指定を正しく読みません。

Windows 7 と Excel 2010 で確認しました。

下記の実装が本件に関連しています。

NVDAObjects/window/excel.py:313
		# Translators: This is presented in Excel to show the current selection, for example 'a1 c3 through a10 c10'
		return _("{firstAddress} {firstContent} through {lastAddress} {lastContent}").format(firstAddress=self.getCellAddress(firstCell),firstContent=firstCell.Text,lastAddress=self.getCellAddress(lastCell),lastContent=lastCell.Text)

これに対して下記の翻訳をあてています:

msgstr "{firstAddress} {firstContent} から {lastAddress} {lastContent}"

読み上げの順番を可変にする必要がなければ、日本語ロケールの変更だけで対応できます。

最後の「選択」は別の場所で付加しており、これを省略可能にする方法はまだ確認していません。

2013-06-06 22:17 Updated by: nishimoto
Comment

以下の仕様を試験的に実装しました:

  • セルが空白の場合は内容のかわりに「空白」と読む
  • 選択範囲が6セル以下のときは、すべてのセルの内容を読み上げて、開始セル位置、終了セル位置を読む。
  • 選択範囲が7セル以上のときは、開始セルの内容、開始セルの位置、終了セルの内容、終了セルの位置、選択したセル数を読む。

release-2013.1jp bf7aa0f

2013-06-10 10:09 Updated by: nishimoto
Comment

jpdev130606 において、以下のご報告をいただいています:

  • Windows7 32ビット、Excel 2003 の組み合わせで、選択セルの読み上げが変更されたことは確認できたが、「空白」は読み上げていない。
  • このバージョンに限らず、点字ディスプレイを接続したときに、例えば A1 から A5 まで選択しても、点字ディスプレイでは A1 から A2 と表示される。

いずれも、まだこちらの環境で確認していません。

後者については、ほかのバージョンでも同じなのか、実際に選択範囲がどのようになっているのか、点字表示の切り替え(NVDA+Ctrl+T)の影響があるかどうか、など、もう少し調べる必要がありそうです。

2013-06-26 13:07 Updated by: nishimoto
  • Ticket Close date is changed to 2013-06-26 13:07
  • Status Update from Open to Closed
  • Resolution Update from None to Fixed
  • Summary Updated
Comment

このチケットは、仕様変更を行ったという記録のために使い、変更を実施したという意味でクローズします。

残った不具合や今後の改良は、新しいチケットで扱います。

2013-07-03 12:40 Updated by: nishimoto
  • Milestone Update from 2013.1.1jp (closed) to (None)
  • Status Update from Closed to Open
  • Resolution Update from Fixed to Accepted
Comment

この仕様変更が改善になっておらず 2013.1.1jp への適用を見合わせたほうがよいというご意見をいただいたので、再検討します。

2013-07-06 15:19 Updated by: nishimoto
Comment

下記のコミットで bf7aa0f の revert と関連ドキュメントの削除を行いました。

release-2013.1jp 585dbc7

2013-08-03 17:38 Updated by: nishimoto
Comment

本チケットの作業を再検討したいと思います。

bitbucket リポジトリ nvdajp ブランチ ti31413 リビジョン dbb1327

po ファイルをいじるとマージが面倒なので、メッセージは日本語で書いています。

  • 選択されたセル数に関わらず(選択範囲の各セルの内容)+(開始セル番地)+「から」+(終了セル番地)と通知する
  • 中身の入っていないセルは「ブランク」と読み上げる

なおいままで blank は ja のメッセージロケールで「空行」と翻訳しているので、ここでは _("blank") を使わずに、カタカナで「ブランク」を入れています。

2013-08-26 11:17 Updated by: nishimoto
Comment

本チケットはいまのところ 2013.2jp をターゲットにしていませんが、念のため release-2013.2jp ブランチをマージしておきました。

To ssh://git@bitbucket.org/nvdajp/nvdajp.git
   dbb1327..2eb3808  ti31413 -> ti31413

Excel のセル範囲読み上げについて、スナップショットを作って検討していただいたほうがよいでしょうか?

ここまでの作業は、リリースに反映させるためというよりも、仕様について議論をしていただくための試作という位置づけで考えています。

本件のような課題は、できそうなことを開発者から提案するだけではまとまらないように思います。

まずユーザーの立場からの要求仕様をまとめること、この問題を日本語チームが独自にやるのか、本家に改善要求を出して本家に任せるのか、といった議論が必要と思います。

引き続きご議論をよろしくお願いします。

2013-09-25 17:32 Updated by: nishimoto
Comment

下記のコミットにて

ti31413 660d906

通知方法を「(開始セル番地)から(終了セル番地)」+(選択範囲の各セルの内容)に変更しました。

通知方法のカスタマイズというご要望もあると思いますが、まず、デフォルトの通知方法を少しでも改良することが可能かどうか検討させてください。

2013-10-11 20:57 Updated by: nishimoto
Comment

しばらくこの作業を jpnext にマージしていたのですが、2013.3jp への反映を見送りたいと思います。

これまでの作業にあまりよい評価が得られないこと、より深い議論や調査が必要であること、などが理由ですが、 本家の nvda-devel で Excel サポート改善の議論が盛り上がっているので、本家の作業をちゃんと追いかけることも重要と思います。

Attachment File List

No attachments

Edit

Please login to add comment to this ticket » Login